//+---------------------------------------------------------------------+
//|                                                              Vo.mq5 | 
//|                                            Copyright  2009, Krokus | 
//|                                                                     | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2009, Krokus"
#property link ""
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----       DodgerBlue 
#property indicator_color1 clrDodgerBlue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  " "

//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1;
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint XPeriod=20; //  
input Smooth_Method XMA_Method=MODE_JJMA; // 
input uint XLength=5; //                     
input int XPhase=15; // ,
  // JJMA    -100 ... +100,     ;
  //  VIDIA   CMO,  AMA    
input int Shift=0; //      
//+-----------------------------------+

//----   ,    
//      
double IndBuffer[];

//----      
double dPriceShift;
//----      
int min_rates_,min_rates_total;
//+------------------------------------------------------------------+   
//| Vo indicator initialization function                             | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_=int(XPeriod);
   min_rates_total=min_rates_+XMA1.GetStartBars(XMA_Method,XLength,XPhase);
//----       
   XMA1.XMALengthCheck("XLength",XLength);
   XMA1.XMAPhaseCheck("XPhase",XPhase,XMA_Method);
   
//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//----       
   ArraySetAsSeries(IndBuffer,true);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"Vo");
   
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+ 
//| Vo iteration function                                            | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----        
   int limit,maxbar=rates_total-1-min_rates_;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
        limit=maxbar; //      
   else limit=rates_total-prev_calculated; //      
    
//----         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);

//----    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      double HH=high[ArrayMaximum(high,bar,XPeriod)];
      double LL=low[ArrayMinimum(low,bar,XPeriod)];
      IndBuffer[bar]=XMA1.XMASeries(maxbar,prev_calculated,rates_total,XMA_Method,XPhase,XLength,(HH-LL)/_Point,bar,true);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
